function [t, p, q] = SympEuler(p0, q0, tspan, h)
% symplectic Euler for
% 
%  [p',q'] = [p,q]/(p^2 + q^2)
%
% Input paramters:
% p0: initial value for p
% q0: initial value for q
% tspan: [t0, T] starting and stopping time
% h: timestep size
%
% Outputparameters
% t: dicrete time points
% p: solution for p at time points
% q: solution for q at time points

% Time intervall
% number of time steps
N = ceil(diff(tspan)/h);
h = diff(tspan)/N;
t = linspace(tspan(1),tspan(2),N+1);

% memory allocation
p = zeros(1,N+1); p(1) = p0;
q = zeros(1,N+1); q(1) = q0;

% functions for each equation
dp = @(P,Q)  ;
dq = @(P,Q)  ;

for k = 2:length(t)
  % solve p implicitly
  F = @(P)  ;
  options = optimset('Display','off');  % Turn off Display
  p(k) =  ;
  
  % calculate q explicitly
  q(k) =  ;
end