% script for convergence studies 

% allocate memory
kmax = ;
h =  ;
N = length(h);
err_rk = zeros(1,N);
err_se = zeros(1,N);

% stop time
T = ;

% initial data
p0 = ;
q0 = ;

% exact solution
p_ex = ;
q_ex = ;

for k = 1:N
  [t, prk, qrk] = RK4( );
  err_rk(k) =  ;
  
  [t, pse, qse] = SympEuler( );
  err_se(k) =  ;
end

figure(1)
loglog(h,err_rk,'r*-', h, h.^4/10^10, 'k-.',h, err_se, 'b+-', h, h, 'k:')
grid on
legend('Runge-Kutta', 'Order 4', 'Symplectic Euler', 'Order 1',...
       'Location','SouthEast')
print -depsc 'errorRate.eps'

% find convergence rate
p=polyfit(log(h),log(err_se),1);
fprintf('Convergence rate of SympEuler = %2.4f\n',p(1));
p=polyfit(log(h(1:end-2)),log(err_rk(1:end-2)),1);
fprintf('Convergence rate of RK4 = %2.4f\n',p(1));
